unit u_Errorlog;

interface

uses SysUtils, Forms, Dialogs, ShellApi;


procedure wErr(Value: String;typ:integer);
procedure FileCheck(Path: String;typ:integer);
function GetFilePath:string;

implementation

uses main,u_tools;

var
  ErrPath: string;  // Pfad des aufrufenden Programmes
  bzugross:boolean;
procedure GetActErrorLog;
begin
  ErrPath:=AddBackSlash(ExtractFilePath(Application.Exename));
end;

function GetFilePath:string;
begin
  GetFilePath:=ErrPath;
end;

procedure FileCheck(Path: String;typ:integer);
var byteFile: File of Byte;
    txtFile: TextFile;
begin
  if FileExists(Path) then
  begin                                  // datei existiert
    if typ=3 then
      Rewrite(byteFile, Path)            // datei wird neu angelegt
    else
      AssignFile(byteFile, Path);
    Reset(byteFile);
    CloseFile(byteFile);
  end
  else                                   // datei existiert nicht
  begin
    Assign(txtFile, Path);
    Rewrite(txtFile);                    // datei anlegen
    if (typ=2) then begin
      Append(txtFile);
      Writeln(txtFile,'Provider,IP-Verbindung,IP-Provider,Beginn,Ende,Dauer,Kosten,Benutzer,Einwahlnr.');  // kopfzeile
    end;
    CloseFile(txtFile);
  end;
end;


procedure wErr(Value: String;typ:integer);
var txtFile:TextFile;
    LogPath:String; // Pfad der Exe-Datei und Dateiname (hier Error.log)
begin

  case typ of
    1: begin
      LogPath:=ErrPath + 'logfile.txt';
    end;
    2: begin
      LogPath:=ErrPath + 'logfile.csv';
    end;
    3: begin
      LogPath:=ErrPath + 'key.bin';
    end;
    4: begin
      LogPath:=ErrPath + 'watchy.ini';
    end;
  end;
  try
    FileCheck(LogPath,typ);
    AssignFile(txtFile, LogPath);
    Append(txtFile);
    if typ=3 then
      Writeln(txtFile,Value)  // registrierung
    else if bzugross=false then
      Writeln(txtFile,datetimetostr(now)+' - '+Value);  // Fehlermeldung
    CloseFile(txtFile);
  except
    MessageDlg('Fehler beim Schreiben vom logfile!', mtError, [mbOK], 0);
  end;
end;

initialization

GetActErrorLog;

end.
