unit main;

//  Shuffler V1.4
// (C) 2000 Hermann Weigl
//  email : webmaster@hermann-weigl.de
//  URL   : http://www.hermann-weigl.de


// Achtung: Wenn der Startparameter 'close' bergeben wird, dann beendet sich
// die Applikation nach dem Austauschen von Bildschirmschoner/Hintergrundbild.

// Weitere Infos zu dem Programm gibt es unter  http://www.hermann-weigl.de  .

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,registry, ExtCtrls, FileCtrl,u_errorlog, Menus,jpeg, Buttons,
  ComCtrls,shellapi;

const WM_TASKBAREVENT = WM_USER+1;
version:string='V 1.4';

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Ende1: TMenuItem;
    Info1: TMenuItem;
    Einstellungen1: TMenuItem;
    Timer1: TTimer;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    ListBox1: TListBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    DriveComboBox1: TDriveComboBox;
    Chk_vorschau: TCheckBox;
    Panel2: TPanel;
    Image1: TImage;
    btn_entfernen: TButton;
    btn_ende: TButton;
    Panel3: TPanel;
    btn_aendern: TButton;
    btn_add: TButton;
    btn_close: TButton;
    Label9: TLabel;
    Panel4: TPanel;
    ListBox2: TListBox;
    Button5: TButton;
    Label1: TLabel;
    Panel5: TPanel;
    ListBox3: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ListBox4: TListBox;
    ListBox5: TListBox;
    btn_scr_speichern: TButton;
    scrTimer1: TTimer;
    PopupMenu1: TPopupMenu;
    Einstellungen2: TMenuItem;
    Beenden1: TMenuItem;
    Timer2: TTimer;
    Image2: TImage;
    Beenden2: TMenuItem;
    Verstecken1: TMenuItem;
    procedure btn_endeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btn_entfernenClick(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure btn_addClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure btn_closeClick(Sender: TObject);
    procedure Einstellungen1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btn_aendernClick(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure scrTimer1Timer(Sender: TObject);
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Einstellungen2Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
    Function LogFiles( Const path: String; Const SRec: TSearchRec ): Boolean;
  public
    { Public-Deklarationen }
    procedure WMTASKBAREVENT(var message: TMessage); message WM_TASKBAREVENT;
  end;

type
  TLogFunct = Function( Const path: String; Const SRec: TSearchRec ): Boolean
                of Object;

var
  Form1: TForm1;
  b_changed:bool;
  b_new_day:bool;
  index,anzahl:integer;
  scrindex,scranzahl:integer;
  aktuellesbild:string;
  bregistriert:bool;

procedure ChangeWallpaper(BmpName: String);
procedure Changescrsaver(Name: String;anzeige:bool);
procedure vorschau(bild: String);
procedure wechseln;
procedure srcwechseln(anzeige:bool);
Procedure FindRecursive( Const path: String; Const mask: String;
                         LogFunction: TLogFunct);
procedure RunSaver(SaverPath, SaverName, SaverParam : String);
function ScreenSaverOff:bool;

implementation

uses info1, einstell2,u_tools,u_CloseApp;



{$R *.DFM}

procedure TForm1.WMTASKBAREVENT(var message: TMessage);
var point : TPoint;
begin
    case message.LParamLo of
         WM_LBUTTONDBLCLK : begin
                                 form1.show;
                            end;
         WM_RBUTTONDOWN   : begin
                                 GetCursorPos(point);
                                 popupmenu1.popup(point.x,point.y);
                            end;
    end;
end;

procedure TaskBarAddIcon;
var tnid : TNOTIFYICONDATA ;
begin
    tnid.cbSize := sizeof(TNOTIFYICONDATA); // Grenangabe der Struktur
    tnid.Wnd := Form1.handle;               // Handle des Message-Empfngers
    tnid.uID := 1;                          // ID beliebig
    tnid.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;  // siehe Tabelle
    tnid.uCallbackMessage := WM_TASKBAREVENT;        // Message# fr Form1
    tnid.hIcon := form1.image2.picture.icon.handle;  // Iconhandle
    strcopy(tnid.szTip,'Shuffler');                // Tooltiptext
    Shell_NotifyIcon(NIM_ADD, @tnid);                // Registrieren ...
end;

procedure TaskBarRemoveIcon;
var tnid : TNOTIFYICONDATA ;
begin
    tnid.cbSize := sizeof(TNOTIFYICONDATA);
    tnid.Wnd := Form1.handle;
    tnid.uID := 1;
    Shell_NotifyIcon(NIM_DELETE, @tnid);
end;

procedure TForm1.FormShow(Sender: TObject);
var
  regist:TRegistry;
  RegData: TRegDataInfo;
  s:string;
  F:Textfile;
  i:integer;
begin
  regist:=TRegistry.Create;
  regist.Rootkey:=HKEY_CURRENT_USER;
  regist.OpenKey('\Software\weigl\shuffler',TRUE);
  if regist.GetDataInfo('index', RegData) = TRUE then begin
    b_new_day:=false;
    s:=regist.ReadString('last_day');
    if (s<>datetostr(now)) then begin
      b_new_day:=true;
      regist.WriteString('last_day',datetostr(now));
    end;
    index:=regist.ReadInteger('index');
    anzahl:=regist.ReadInteger('anzahl');
    einstell.chk_wall_taeglich.checked:=regist.ReadBool('wall_taeglich');
    einstell.chk_zyklisch.checked:=regist.ReadBool('zyklisch');
    if(regist.ReadBool('min')=true)
      then einstell.chk_min.checked:=true
      else einstell.chk_std.checked:=true;
    einstell.edit1.text:=inttostr(regist.readinteger('dauer'));
    timer1.enabled:=einstell.chk_zyklisch.checked;
    if (einstell.chk_min.checked=true)
      then timer1.interval:=strtoint(einstell.edit1.text)*60*1000
      else timer1.interval:=strtoint(einstell.edit1.text)*3600*1000;

    scrindex:=regist.ReadInteger('scrindex');
    scranzahl:=regist.ReadInteger('scranzahl');
    einstell.chk_screen_taeglich.checked:=regist.ReadBool('screen_taeglich');
    einstell.scrchk_zyklisch.checked:=regist.ReadBool('scrzyklisch');
    if(regist.ReadBool('scrmin')=true)
      then einstell.scrchk_min.checked:=true
      else einstell.scrchk_std.checked:=true;
    einstell.scredit1.text:=inttostr(regist.readinteger('scrdauer'));
    scrtimer1.enabled:=einstell.scrchk_zyklisch.checked;
    if (einstell.scrchk_min.checked=true)
      then scrtimer1.interval:=strtoint(einstell.scredit1.text)*60*1000
      else scrtimer1.interval:=strtoint(einstell.scredit1.text)*3600*1000;
    einstell.chk_zufall.checked:=regist.ReadBool('zufall');
    einstell.scrchk_zufall.checked:=regist.ReadBool('scrzufall');
    left:=regist.ReadInteger('left');
    top:=regist.ReadInteger('top');
    einstell.chk_logdatei.checked:=regist.ReadBool('logdatei');
    einstell.chk_minimieren.checked:=regist.ReadBool('minimieren');

    einstell.chk_wall_taeglichClick(self);
    einstell.chk_screen_taeglichClick(self);
    einstell.chk_zyklischClick(self);
    einstell.scrchk_zyklischClick(self);
  end
  else begin
    index:=0;
    scrindex:=0;
    regist.WriteInteger('index',0);
    regist.WriteInteger('anzahl',0);
    regist.WriteInteger('zyklisch',0);
    regist.WriteInteger('min',0);
    regist.WriteInteger('dauer',30);
    regist.WriteInteger('scrindex',0);
    regist.WriteInteger('scranzahl',0);
    regist.WriteInteger('scrzyklisch',0);
    regist.WriteInteger('scrmin',0);
    regist.WriteInteger('scrdauer',30);
    regist.WriteInteger('scrzufall',0);
    regist.WriteInteger('zufall',0);
    regist.WriteInteger('top',100);
    regist.WriteInteger('left',100);
    regist.WriteInteger('logdatei',0);
  end;
  regist.destroy;
  listbox1.Items.Clear;
  AssignFile(F,GetFilePath+'wallpaper.ini');
  Reset(F);
  i:=0;
  while not Eof(F) do begin
    if ((not bregistriert) and (i>4)) then begin
      showmessage('In der nicht registrierten Version ist die Anzahl der Bildschirmschoner begrenzt.'
               +#13+'Bitte lassen Sie sich registrieren');
      exit;
    end;
    readln(F,s);
    listbox1.Items.add(s);
    inc(i);
  end;
  closefile(F);

  if not bregistriert then
    Verstecken1.enabled:=false;

  listbox4.Items.Clear;
  listbox5.Items.Clear;
  AssignFile(F,GetFilePath+'scrsaver.ini');
  Reset(F);
  i:=0;
  while not Eof(F) do begin
    if ((not bregistriert) and (i>2)) then begin
      showmessage('In der nicht registrierten Version ist die Anzahl der Bildschirmschoner begrenzt.'
               +#13+'Bitte lassen Sie sich registrieren');
      exit;
    end;
    readln(F,s);
    listbox4.Items.add(s);
    s:=GetFileDisplayName(s);
    delete(s,length(s)-3,4);
    listbox5.items.add(s);
    inc(i);
  end;
  closefile(F);
  if ((Paramcount=1) and (ParamStr(1)='close')) then begin
  // wallpaper ndern
    wechseln;
    srcwechseln(false);
    close;
  end
  else begin
  // einstellungen ndern
    b_changed:=false;
    with Label9 do begin
      Font.Color:=clBlue;
      Font.Style:=[fsUnderline];
      Cursor:=crHandPoint;
    end;
    with Label1 do begin
      Font.Color:=clBlue;
      Font.Style:=[fsUnderline];
      Cursor:=crHandPoint;
    end;
  end;
end;

procedure wechseln;
begin
  if ((b_new_day=true) and (einstell.chk_wall_taeglich.checked=true)) // abfrage auf tglichen wechsel
  or (einstell.chk_wall_taeglich.checked=false)
  then begin
    if einstell.chk_zufall.checked=true then begin
      Randomize;
      index:=Random(anzahl);
    end
    else begin
      if index<anzahl-1
        then inc(index)
        else index:=0;
    end;
    changewallpaper(form1.listbox1.items[index]);
  end;
end;

procedure srcwechseln(anzeige:bool);
begin
  if ((b_new_day=true) and (einstell.chk_screen_taeglich.checked=true)) // abfrage auf tglichen wechsel
  //or (einstell.chk_screen_taeglich.checked=false)
  then begin
    if einstell.scrchk_zufall.checked=true then begin
      Randomize;
      scrindex:=Random(scranzahl)
    end
    else begin
      if ((scrindex<scranzahl-1) and (scranzahl>0))
        then inc(scrindex)
        else scrindex:=0;
    end;
    Changescrsaver(form1.listbox4.items[scrindex],anzeige);
  end;
end;

procedure ChangeWallpaper(BmpName: String);
var
  regist:TRegistry;
  Reg: TRegIniFile;
  b : TBitmap;
  Jpg : TJPEGImage;
begin
  if FileExists(BmpName) then begin
    if einstell.chk_logdatei.checked=true then
      werr(bmpname,1);
    if lowercase(ExtractFileExt(BmpName))='.bmp' then begin
      Reg := TRegIniFile.Create('Control Panel');
      Reg.WriteString('desktop','Wallpaper',BmpName);
      Reg.WriteString('desktop', 'TileWallpaper', '0');
      Reg.Free;
      SystemParametersInfo(
         SPI_SETDESKWALLPAPER, 0, PChar(bmpname),
         SPIF_SENDCHANGE or SPIF_UPDATEINIFILE);
    end
    else if lowercase(ExtractFileExt(BmpName))='.jpg' then begin
      b := TBitmap.Create;
      jpg := TJPEGImage.Create;
      jpg.LoadFromFile(bmpname);
      b.Assign(jpg);
      b.SaveToFile(ExtractFilePath(Application.Exename)+'weigl.bmp');
      Reg := TRegIniFile.Create('Control Panel');
      Reg.WriteString('desktop','Wallpaper',ExtractFilePath(Application.Exename)+'weigl.bmp');
      Reg.WriteString('desktop', 'TileWallpaper', '0');
      Reg.Free;
      SystemParametersInfo(
         SPI_SETDESKWALLPAPER, 0, PChar(ExtractFilePath(Application.Exename)+'weigl.bmp'),
         SPIF_SENDCHANGE or SPIF_UPDATEINIFILE);
    end;
  end
  else begin
    if einstell.chk_logdatei.checked=true then
      werr('Die Datei '+bmpname+'wurde nicht gefunden !',1);
    showmessage('Die Datei '+bmpname
               +#13+'wurde nicht gefunden !');
  end;
  regist:=TRegistry.Create;
  regist.Rootkey:=HKEY_CURRENT_USER;
  regist.OpenKey('\Software\weigl\shuffler',TRUE);
  regist.WriteInteger('index',index);
  regist.destroy;
end;

procedure Changescrsaver(Name: String;anzeige:bool);
var
  regist:TRegistry;
  Reg: TRegIniFile;
  instance:hwnd;
  erg:bool;
begin
  erg:=false;
  if einstell.chk_logdatei.checked=true then
    werr(name,1);
  //if anzeige=true then
  erg:=ScreenSaverOff();
  if name<>'' then begin
    Reg := TRegIniFile.Create('Control Panel');
    Reg.WriteString('desktop','SCRNSAVE.EXE',Name);
    Reg.Free;
  end;
  if anzeige=true then
    if erg=true then
      RunSaver(ExtractFilePath(name),extractfilename(name),' /s');
  regist:=TRegistry.Create;
  regist.Rootkey:=HKEY_CURRENT_USER;
  regist.OpenKey('\Software\weigl\shuffler',TRUE);
  regist.WriteInteger('scrindex',scrindex);
  regist.destroy;
end;

procedure TForm1.btn_endeClick(Sender: TObject);
var
  i:integer;
  txtFile:TextFile;
  regist:TRegistry;
begin
//  messagebeep($FFFFFFFF);
  FileCheck(GetFilePath+'wallpaper.ini',3);
  AssignFile(txtFile,GetFilePath+'wallpaper.ini');
  Append(txtFile);
  for i:=0 to listbox1.Items.Count-1 do begin
    Writeln(txtFile,listbox1.Items[i]);  // Fehlermeldung
  end;
  CloseFile(txtFile);
  anzahl:=listbox1.Items.Count;

  FileCheck(GetFilePath+'scrsaver.ini',3);
  AssignFile(txtFile,GetFilePath+'scrsaver.ini');
  Append(txtFile);
  for i:=0 to listbox4.Items.Count-1 do begin
    Writeln(txtFile,listbox4.Items[i]);  // Fehlermeldung
  end;
  CloseFile(txtFile);
  scranzahl:=listbox4.Items.Count;

  regist:=TRegistry.Create;
  regist.Rootkey:=HKEY_CURRENT_USER;
  regist.OpenKey('\Software\weigl\shuffler',TRUE);
  regist.WriteInteger('anzahl',listbox1.Items.Count);
  regist.WriteInteger('scranzahl',listbox4.Items.Count);
  regist.destroy;
  b_changed:=false;
  btn_ende.enabled:=false;
  btn_scr_speichern.enabled:=false;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if listbox1.Itemindex>=0 then begin
    btn_entfernen.enabled:=true;
    btn_aendern.enabled:=true;
    if Chk_vorschau.Checked=true then
      vorschau(listbox1.Items[listbox1.Itemindex]);
  end
  else begin
    btn_entfernen.enabled:=false;
    btn_aendern.enabled:=false;
  end;
end;

procedure TForm1.btn_entfernenClick(Sender: TObject);
begin
  listbox1.Items.Delete(listbox1.Itemindex);
  btn_ende.enabled:=true;
  b_changed:=true;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  if Filelistbox1.FileName<>'' then begin
    if Chk_vorschau.Checked=true then
      vorschau(Filelistbox1.FileName);
    btn_add.enabled:=true;
    btn_aendern.enabled:=true;
  end
  else begin
    btn_add.enabled:=false;
    btn_aendern.enabled:=false;
  end;
end;

procedure TForm1.btn_addClick(Sender: TObject);
begin
  if ((not bregistriert) and (listbox1.Items.Count>4)) then
    showmessage('In der nicht registrierten Version ist die Anzahl der Bilder begrenzt.'
               +#13+'Bitte lassen Sie sich registrieren')
  else
    listbox1.Items.add(Filelistbox1.FileName);
  btn_ende.enabled:=true;
  b_changed:=true;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
  info.show;
end;

procedure TForm1.btn_closeClick(Sender: TObject);
begin
  if b_changed=true then begin
    if (MessageDlg ('Wollen Sie Ihre nderungen wirklich verwerfen ? ',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    close;
  end
  else
    close;
end;

procedure TForm1.Einstellungen1Click(Sender: TObject);
begin
  einstell.show;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  wechseln;
end;

procedure TForm1.scrTimer1Timer(Sender: TObject);
begin
  srcwechseln(true);
end;

procedure vorschau(bild:string);
var
  b : TBitmap;
  Jpg : TJPEGImage;
begin
  with Form1 do begin
    if lowercase(ExtractFileExt(bild))='.bmp' then begin
      b := TBitmap.Create;
      b.LoadFromFile(bild);
      panel3.caption:=inttostr(b.Height)+' * '+inttostr(b.Width);
      image1.Picture.Bitmap:=b;
      b.free;
      aktuellesbild:=bild;
    end
    else if lowercase(ExtractFileExt(bild))='.jpg' then begin
      jpg := TJPEGImage.Create;
      jpg.LoadFromFile(bild);
      panel3.caption:=inttostr(jpg.Height)+' * '+inttostr(jpg.Width);
      image1.Picture.Assign(jpg);
      jpg.free;
      aktuellesbild:=bild;
    end;
  end;
end;

procedure TForm1.btn_aendernClick(Sender: TObject);
begin
  ChangeWallpaper(aktuellesbild);
end;

procedure TForm1.TabSheet2Show(Sender: TObject);
begin
  listbox2.Clear;
  listbox3.Clear;
  FindRecursive(WindowsDirectory,'*.scr', LogFiles );
end;

Function TForm1.LogFiles( Const path: String; Const SRec: TSearchRec ): Boolean;
var
  s:string;
Begin
  Listbox2.Items.Add(path+SRec.Name );
  s:=GetFileDisplayName(path+SRec.Name);
  delete(s,length(s)-3,4);
  Listbox3.Items.Add(s);
  Result:=True;   (* proceeed with recursion *)
End;

Procedure FindRecursive( Const path: String; Const mask: String;
                         LogFunction: TLogFunct );
  Var
    fullpath: String;
  Function Recurse( Var path: String; Const mask: String ): Boolean;
    Var
      SRec: TSearchRec;
      retval: Integer;
      oldlen: Integer;
    Begin
      Recurse := True;

      oldlen := Length( path );
      (* phase 1, look for normal files *)
      retval := FindFirst( path+mask, faAnyFile, SRec );

      While retval = 0 Do Begin
        If (SRec.Attr and (faDirectory or faVolumeID)) = 0 Then
          (* we found a file, not a directory or volume label,
             log it. Bail out if the log function returns false. *)

          If not LogFunction( path, SRec ) Then Begin
            Result := False;
            Break;
          End;
        retval := FindNext( SRec );
      End;
      FindClose(SRec);
      If not Result Then Exit;

      (* Phase II, look for subdirectories and recurse thru them *)
      retval := FindFirst( path+'*.*', faDirectory, SRec );
      While retval = 0 Do Begin
        If (SRec.Attr and faDirectory) <> 0 Then (* we have a directory *)
          If (SRec.Name <> '.') and (SRec.Name <> '..') Then Begin
            path := path + SRec.Name + '\';
            If not Recurse( path, mask ) Then Begin

              Result := False;
              Break;
            End;
            Delete( path, oldlen+1, 255 );
          End;
        retval := FindNext( SRec );
      End;
      FindClose( SRec );
    End;
  Begin
    If path = '' Then
      GetDir(0, fullpath)
    Else
      fullpath := path;
    If fullpath[Length(fullpath)] <> '\' Then
      fullpath := fullpath + '\';
    If mask = '' Then
      Recurse( fullpath, '*.*' )
    Else
      Recurse( fullpath, mask );
End;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if listbox3.ItemIndex>=0 then begin
    if ((not bregistriert) and (listbox4.Items.Count>2)) then
      showmessage('In der nicht registrierten Version ist die Anzahl der Bildschirmschoner begrenzt.'
                 +#13+'Bitte lassen Sie sich registrieren')
    else begin
      listbox4.Items.add(listbox2.Items[listbox3.ItemIndex]);
      listbox2.Items.Delete(listbox3.ItemIndex);
      listbox5.Items.add(listbox3.Items[listbox3.ItemIndex]);
      listbox3.Items.Delete(listbox3.ItemIndex);
    end;
    btn_scr_speichern.enabled:=true;
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  if listbox5.ItemIndex>=0 then begin
    listbox2.Items.add(listbox4.Items[listbox5.ItemIndex]);
    listbox4.Items.Delete(listbox5.ItemIndex);
    listbox3.Items.add(listbox5.Items[listbox5.ItemIndex]);
    listbox5.Items.Delete(listbox5.ItemIndex);
    btn_scr_speichern.enabled:=true;
  end;
end;

procedure RunSaver(SaverPath, SaverName, SaverParam : String);
var
  zAppName : String;
  StartupInfo : TStartupInfo;
  ProcessInfo : TProcessInformation;
begin
  if Copy(SaverPath, Length(SaverPath), 1) <> '\' then
    SaverPath := SaverPath + '\';
  zAppName := SaverPath + SaverName + '' + SaverParam;
  FillChar(StartupInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcessInfo,SizeOf(TProcessInformation),#0);
  StartupInfo.cb := Sizeof(StartupInfo);
  CreateProcess(nil,                        {^executable name}
                PChar(zAppName),            {^command line string}
                nil,                        {^process security attributes}
                nil,                        {^thread security attributes}
                false,                      {handle inheritance flag}
                CREATE_NEW_PROCESS_GROUP or {creation flags}
                NORMAL_PRIORITY_CLASS,
                nil,                        {^new environment block}
                nil,                        {^current directory name}
                StartupInfo,                {STARTUPINFO}
                ProcessInfo);               {PROCESSINFO}
end;

procedure TForm1.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
{
  if (Msg.Message = WM_SYSCOMMAND) and
    ((Msg.wParam) = SC_SCREENSAVE) then begin
    Handled := True;
  end;
}
end;

function KillScreenSaverFunc( hwnd, lParam : Integer) : Boolean; stdcall; { used by ScreenSaverOff }
begin
   PostMessage( hwnd, WM_CLOSE, 0, 0 );
   Result := True;
end;

 {--------------------------------------------------------------------------- --}

function ScreenSaverOff:bool;
var
   DeskHand    : HDesk;
begin
   ScreenSaverOff:=true;
   if copy(GetWindowsVersion,1,20)='Windows NT Version 4' then begin
     DeskHand := OpenDesktop( PChar( 'Screen-saver' ), 0, FALSE,
                             DESKTOP_READOBJECTS OR DESKTOP_WRITEOBJECTS );
     if DeskHand <> 0 then begin
       EnumDesktopWindows( DeskHand, @KillScreenSaverFunc, 0 );
       CloseDesktop( DeskHand );
       ScreenSaverOff:=true;
     end
     else ScreenSaverOff:=false;
   end else begin
     Mouse_Event( MouseEventF_Move,  10,  10, 0, 0 );
 {$IFDEF VER90}
     Mouse_Event( MouseEventF_Move, -10, -10, 0, 0 );
 {$ENDIF}
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  reg: TRegistry;
begin
  TaskBarRemoveIcon;
  reg:=TRegistry.Create;
  reg.Rootkey:=HKEY_CURRENT_USER;
  reg.OpenKey('\SOFTWARE\weigl\shuffler',TRUE);
  reg.WriteInteger('left',left);
  reg.WriteInteger('top',top);
  reg.destroy;
end;

procedure TForm1.Einstellungen2Click(Sender: TObject);
begin
  form1.show;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  if ((bregistriert) and (einstell.chk_minimieren.Checked=true)) then begin
    self.hide;
    TaskBarAddIcon;
  end;
  timer2.enabled:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  F: Textfile;
  s,s1,s2:string;
begin
  bRegistriert:=true;

end;

end.

